%global gem_name exception_notification

Name: rubygem-%{gem_name}
Version: 4.0.1
Release: 3%{?dist}
Summary: Exception notification for Rails apps
Group: Development/Languages
License: MIT
URL: https://smartinez87.github.io/exception_notification/3.x/
Source0: https://rubygems.org/gems/%{gem_name}-%{version}.gem
# Remove bundler dependency from Rakefile. Probably cannot go upstream, because
# upstream prefers bundler.
Patch0: rubygem-exception_notification-4.0.0-rake-nobundler.patch
# Remove hard dependency on tinder. Unknown if upstream will be receptive to
# this.
Patch1: rubygem-exception_notification-4.0.0-tinder.patch
Requires: ruby(release)
Requires: ruby(rubygems)
Requires: rubygem(actionmailer) >= 3.0.4
Requires: rubygem(activesupport) >= 3.0.4
BuildRequires: ruby(release)
BuildRequires: rubygems-devel
BuildRequires: rubygem(actionmailer) >= 3.0.4
BuildRequires: rubygem(activesupport) >= 3.0.4
BuildRequires: rubygem(hipchat)
BuildRequires: rubygem(httparty)
BuildRequires: rubygem(minitest)
BuildRequires: rubygem(mocha)
BuildRequires: rubygem(rake)
BuildRequires: rubygem(rails) >= 3.0.4
BuildRequires: rubygem(sqlite3)
BuildArch: noarch
Provides: rubygem(%{gem_name}) = %{version}

%description
The Exception Notification gem provides a set of notifiers for sending
notifications when errors occur in a Rack/Rails application. The built-in
notifiers can deliver notifications by email, campfire rooms or via
webhooks.


%package doc
Summary: Documentation for %{name}
Group: Documentation
Requires: %{name} = %{version}-%{release}
BuildArch: noarch

%description doc
Documentation for %{name}.

%prep
gem unpack %{SOURCE0}

%setup -q -D -T -n  %{gem_name}-%{version}

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

# Remove Bundler dependency from Rakefile
%patch0 -p1
# Remove tinder dependency from tests
%patch1 -p1

# Update for Minitest 5
sed -i -e 's/test\/unit/minitest\/autorun/' test/test_helper.rb

# Remove unnecessary bundler dependency from dummy Rails in test suite
sed -i '/bundler/d' test/dummy/config/boot.rb
# With bundler gone, we need to explicitly load exception_notification here
echo "require 'exception_notification'" >> test/dummy/config/boot.rb

# Remove /usr/bin/env from shebang so RPM doesn't consider this a dependency
sed -i 's|#!/usr/bin/env ruby|#!/usr/bin/ruby|' test/dummy/script/rails

# Remove developer-only files.
# https://github.com/smartinez87/exception_notification/pull/202
for f in .gemtest .gitignore .travis.yml \
Appraisals Gemfile Gemfile.lock \
test/dummy/.gitignore \
test/dummy/lib/tasks/.gitkeep \
test/dummy/public/stylesheets/.gitkeep ; do
  rm $f
  sed -i "s|\"$f\",||g" %{gem_name}.gemspec
done

%build
# Create the gem as gem install only works on a gem file
gem build %{gem_name}.gemspec

%gem_install

# remove unecessary gemspec
pushd .%{gem_instdir}
  rm %{gem_name}.gemspec
popd

%install
mkdir -p %{buildroot}%{gem_dir}
cp -pa .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

%check
pushd .%{gem_instdir}
  # The reason we simply run "rake" here is that the Rakefile contains some
  # steps for setting up the sqlite database. These are non-trivial to do
  # outside of Rake.
  # The default command is to stage the DB, then run the tests. Here we go.
  rake
popd


%files
%dir %{gem_instdir}
%doc %{gem_instdir}/MIT-LICENSE
%doc %{gem_instdir}/README.md
%{gem_libdir}
%exclude %{gem_cache}
%{gem_spec}

%files doc
%doc %{gem_docdir}
%doc %{gem_instdir}/CHANGELOG.rdoc
%doc %{gem_instdir}/CONTRIBUTING.md
%{gem_instdir}/examples
%exclude %{gem_instdir}/test
%exclude %{gem_instdir}/gemfiles
%exclude %{gem_instdir}/Rakefile


%changelog
* Wed Jun 11 2014 Ken Dreyer <ktdreyer@ktdreyer.com> - 4.0.1-3
- Remove dot files in %%prep
- Move README to main package
- Exclude more files from -doc
- Drop hipchat patch and BR: rubygem(hipchat)
- Remove gem2rpm comment
- Update URL
- Update for Minitest 5 (RHBZ #1107105)

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 4.0.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Thu Oct 03 2013 Ken Dreyer <ktdreyer@ktdreyer.com> - 4.0.1-1
- Update to 4.0.1
- Drop upstreamed patches and LICENSE file
- Drop BR: ruby, since BR: ruby(release) does the same thing
- Patch out the dependency on hipchat

* Fri Sep 06 2013 Ken Dreyer <ktdreyer@ktdreyer.com> - 4.0.0-2
- Close -doc %%description with "."
- Remove executable attr from LICENSE
- Remove developer-only .gitkeep and .gitignore files

* Wed Sep 04 2013 Ken Dreyer <ktdreyer@ktdreyer.com> - 4.0.0-1
- Update to 4.0.0

* Fri Aug 10 2012 Ken Dreyer <ktdreyer@ktdreyer.com> - 2.6.1-1
- Initial package, created by gem2rpm 0.8.1
